local RollWinner = {}
_G["RollWinner"] = RollWinner;

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- Variablen werden geladen
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

local RollWinner_Options = {}
RollWinner_isLoaded = false;

local RollRunning = false;

local Winner = {Name = "", Roll = 0};
local Looser = {Name = "", Roll = 101};

local PlayerInfo = {Name = "", Roll = 0};
local PlayerRolled = {};

local MemberMAX = 0;
local MemberRolled = 0;

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- initialisierung des addons
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function RollWinner_Initialise(this)
	this:RegisterEvent("CHAT_MSG_SYSTEM_VALUE");
	this:RegisterEvent("VARIABLES_LOADED");
	DEFAULT_CHAT_FRAME:AddMessage(ROLLWINNER_TITLE.."\n Command '/rw reset'",0,255,255);
	RollWinner_isLoaded = true;	
end

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- SLASH CMDS
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SLASH_RollWinner1 = "/rw";
SLASH_RollWinner2 = "/RollWinner";

SlashCmdList["RollWinner"] = RollWinner_parsecmd;

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- die CMD's werden spezifiziert
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function RollWinner_parsecmd(ebox, cmd)
	if(cmd == nil or cmd == "") then
		RollWinner_Debug("Test erfolgreich");
	elseif (cmd == "reset") then
		RollWinner_Reset();
		RollWinner_Debug("Rollstatus zur\195\188ckgesetzt");
		DEFAULT_CHAT_FRAME:AddMessage(ROLLWINNER_MSG_RESET,0,255,255);
	end
end

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- Optionen werden initial auf default gesetzt
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

RollWinner_Options["DebugFlag"] = false;

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- System Nachrichten werden geprft und der Event erkannt
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function RollWinner_OnEvent(event, arg1,arg2,arg3,arg4)
	if event == "CHAT_MSG_SYSTEM_VALUE" then
		if (IsPartyLeader("player") or IsRaidLeader("player")) then
			msg = arg1;
			RollWinner_Debug("event ist "..event);
			RollWinner_Debug("msg ist "..msg);
			-- RollWinner_Debug("arg2 ist "..arg2);
			-- RollWinner_Debug("arg3 ist "..arg3);
			-- RollWinner_Debug("arg4 ist "..arg4);
			RollWinner_sys_msg_received(msg);
		end
	end
end

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- die richtige Nachricht wird herausgefiltert und mit den Pattern geprft
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function RollWinner_sys_msg_received(msg)
	local pattern = ROLLWINNER_ROLL_PATTERN;
	RollWinner_Debug("die pattern sind: "..pattern);
	RollWinner_Debug("die msg ist: "..msg);

	-- Check to see if it's a /random roll:
	local player, roll, min_roll, max_roll, report
		if string.find(msg, pattern) then
			_, _, player, roll, min_roll, max_roll = string.find(msg, pattern);
		RollWinner_Debug("der Player heisst: "..player);
		RollWinner_Debug("und Rollte: "..roll);
		RollWinner_Debug("min roll: "..min_roll);
		RollWinner_Debug("max roll: "..max_roll);
		end
	RollWinner_ProcessRoll(player, roll, min_roll, max_roll);
end

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- das Gewrfelte wird gespeichert und der hchste / tiefste ermittelt
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

function RollWinner_ProcessRoll(player, roll, min_roll, max_roll)
	RollWinner_Debug("jetzt kommt der mathematische Teil");
		roll = tonumber(roll);
	min_roll = tonumber(min_roll);
	max_roll = tonumber(max_roll);
	
	if (RollRunning == false) then
		RollWinner_Reset("PARTY");
		RollWinner_Debug("Variablen zur\195\188ckgesetzt");
	end;
	
	RollWinner_Debug("member in party: "..MemberMAX);
	
	if (RollWinner_CheckIfRolled(player) == false) then
		PlayerInfo.Name = player;
		PlayerInfo.Roll = roll;
		table.insert(PlayerRolled, PlayerInfo);
		RollWinner_Debug("in table: "..PlayerInfo.Name);

		if (roll > Winner.Roll) then
			Winner.Name = player;
			Winner.Roll = roll;
		end;
		if (roll < Looser.Roll) then
			Looser.Name = player;
			Looser.Roll = roll;
		end;
		MemberRolled = MemberRolled + 1;
			RollWinner_Debug("member Rolled: "..MemberRolled);
		if (MemberRolled == MemberMAX) then																
			RollWinner_STOPPRoll("PARTY");
		end;
	else
		SendChatMessage(player..ROLLWINNER_MSG_CHEAT, "PARTY");
		--SendChatMessage("Du hattest schon gewuerfelt(Es war die "..RollWinner_GetNumberRolled(player)..").", "WHISPER", 0, player);
	end;
end



-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- berprfen, ob der Player bereits gerollt hat
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function RollWinner_CheckIfRolled(name)
	for i = 1, table.getn(PlayerRolled), 1 do
		if (name == PlayerRolled[i].Name) then
			return true;
		end;
    end;
    return false;
end;

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- Zahl auslesen, welche gerollt wurde
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function RollWinner_GetNumberRolled(name)
	for i = 1, table.getn(PlayerRolled), 1 do
		if (name == PlayerRolled[i].Name) then
			return PlayerRolled[i].Roll;
		end;
    end;
    return 0;
end;

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- Rcksetzung der Variablen / starten des Rolls
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function RollWinner_Reset(Channel)
	RollWinner_Debug("R\195\188cksetzung der Variablen");
	Winner.Name = "";
	Winner.Roll = 0;
	Looser.Name = "";
	Looser.Roll = 101;
	PlayerRolled = {};
	MemberMAX = 0;
	if     (GetNumRaidMembers()>0)  then 
		MemberMAX=GetNumRaidMembers()+0;
--		GetNameRaidMembers();
	elseif (GetNumPartyMembers()>0) then 
		MemberMAX=GetNumPartyMembers()+0; 
		GetNamePartyMembers();
	end;
	MemberRolled = 0;
	RollRunning = true;
end;

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- Wie heissen die Members?
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function GetNamePartyMembers()

PartyMember = {Name = "", ID = ""};
PartyNumber = 0;
limit = MemberMAX - 1;
unitId = "party";
	tempname = UnitName("player");
	PartyMember.Name = tempname;
	PartyMember.ID = 0;
		for i = 1, limit do
			tempname = UnitName(unitId .. i);
			if (tempname ~= nil) then
				PartyMember.Name = tempname;
				PartyMember.ID = i;
				PartyNumber = PartyNumber + 1;
			end
		end
		
		for i = 1, table.getn(PartyMember), MemberMAX do
		if (PartyMember[i].Name) then
		DEFAULT_CHAT_FRAME:AddMessage(PartyMember.Name, 0.5, 0.5, 0.5);
		end
		end
end

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- STOPPRoll
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
function RollWinner_STOPPRoll(Channel)
	RollWinner_Debug("stopp roll");
	local Winners = "";
	local Loosers = "";
	RollRunning = false;
	if (Winner.Name ~= "") then
		Winners = ROLLWINNER_MSG_WINNER..Winner.Name..ROLLWINNER_MSG_WITH..Winner.Roll.."\n";
	end;
	if (Looser.Name ~= "") then
		Loosers = " ("..ROLLWINNER_MSG_LOOSER..Looser.Name..ROLLWINNER_MSG_WITH..Looser.Roll..")\n".."~~~~~~~~~~~~~~~~~~~~~~~~~~~~";
	end;
	if (Winners ~= "") then
		SendChatMessage("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n"..ROLLWINNER_MSG_ROLLSTOP..table.getn(PlayerRolled)..ROLLWINNER_MSG_STARTERS..Winners..Loosers, Channel);
	else
		SendChatMessage("Gibts nicht ;o)", Channel);
	end;
end;

-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-- Debug Funkion
-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		
function RollWinner_Debug(...)
	if ( RollWinner_Options["DebugFlag"] ) then
		local sDebug = "#";
		for i = 1, select("#", ...) , 1 do
			if ( select(i, ...) ) then
				sDebug = sDebug .. tostring(select(i, ...) ) .. "#";
			end
		end
		DEFAULT_CHAT_FRAME:AddMessage(sDebug, 0.5, 0.5, 0.5);
	end
end


------ Ende des Scripts ------		